#include <bits/stdc++.h>

using namespace std;
#define MAXN 500005
#define MAXBIT 45
typedef long long ll;
ll a[MAXN];
int cnt[MAXBIT];
const ll INF = 1e18;

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        for(int j = 0; j < MAXBIT; j++)
        {
            if(a[i]&(1LL<<j))
            {
                cnt[j]^=1;
            }
        }
    }
    ll ans = INF;
    for(int j = 0; j < MAXBIT; j++)
    {
        ll s=0LL;
        for(int i = 0; i < n; i++)
        {
            if(! (a[i]&(1LL<<j)))
            {
                s+=(1LL<<j);
            }
        }
        bool fl = false;
        for(int k = 0; k < MAXBIT; k++)
        {
            if(cnt[k]==1 && k!=j)
            {
                ans=min(ans,s);
                fl=true;
                break;
            }
        }
        if(fl)continue;
        if(n%2==1)
        {
            ans=min(ans,s);
            continue;
        }
        for(int k = 0; k < MAXBIT; k++)
        {
            if(k==j)continue;
            if(cnt[k]==1)continue;
            for(int i = 0; i < n; i++)
            {
                if(a[i]&(1LL<<j))continue;
                if(a[i]&(1LL<<k))
                {
                    ll pom = abs((1LL<<j)-(1LL<<k))-(1LL<<j);
                    ans=min(ans,s+pom);
                }
            }
        }
        for(int k = 0; k < MAXBIT; k++)
        {
            if(cnt[k]==1)continue;
            if(k==j)continue;
            ans=min(ans,s+(1LL<<k));
            break;
        }
    }
    cout << ans;
    return 0;
}